#!/usr/bin/env python
# -*- coding=utf-8 -*-

from hashlib import sha1
import hmac
import base64
import binascii
from optparse import OptionParser

def calculate_signature(app_key, app_id, ts, random_str, room_name, uid, expect_ts):
    data = "ACS{}{}{}{}{}{}".format(app_id, ts, random_str, room_name, uid, expect_ts)
    print "data to calculate signature:{}".format(data)
    signature = hmac.new(app_key, data, sha1).digest()#.encode('base64').rstrip()
    signature = binascii.b2a_hex(signature)
    print "signature:{}".format(signature)
    return signature

def calculate_token(version, signature, ts, random_str, expect_ts):
    token = "{}{}{}{}{}".format(version, signature, ts, random_str, expect_ts)
    print "token:{}".format(token)

if __name__ == "__main__":
    usage = " -- for example: ./signature.py -s app_key -a app_id -t ts -r random_str -o room -u uid -e expect_ts"
    parser = OptionParser(usage) 
    parser.add_option("-s", "--sk", dest="app_key", help="app key", action = "store", type="string")
    parser.add_option("-a", "--aid", dest="app_id", help="app id", action = "store", type="string")
    parser.add_option("-t", "--ts", dest="ts", help="ts", action = "store", type="string")
    parser.add_option("-r", "--rs", dest="random_str", help="random_str", action = "store", type="string")
    parser.add_option("-o", "--room", dest="room", help="random_str", action = "store", type="string")
    parser.add_option("-u", "--uid", dest="uid", help="uid", action = "store", type="string")
    parser.add_option("-e", "--ets", dest="expect_ts", help="expect_ts", action = "store", type="string")
    (opt, args) = parser.parse_args()

    sig = calculate_signature(opt.app_key, opt.app_id, opt.ts, opt.random_str, opt.room, opt.uid, opt.expect_ts)
    calculate_token("004", sig, opt.ts, opt.random_str, opt.expect_ts)



